# How-to guides

{% hint style="info" %}
**You are looking at the old Evidently documentation**: this API is available with versions 0.6.7 or lower. Check the newer docs version [here](https://docs.evidentlyai.com/introduction).
{% endhint %}

These example notebooks and how-to guides show how to solve specific tasks. You can also browse on [GitHub](https://github.com/evidentlyai/evidently/tree/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions).

| Topic            | Question                                                                                   | Guide or example                                                                                                                                                                                                                                                        |
| ---------------- | ------------------------------------------------------------------------------------------ | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Input data       | How to load data from different sources to pandas.Dataframes?                              | <ul><li><a href="/pages/EXkwP7i95lAkzWycJi2T">Guide</a></li></ul>                                                                                                                                                                                                       |
| Input data       | How to use column mapping?                                                                 | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_use_column_mapping.ipynb">Jupyter notebook</a></li></ul>                                                                       |
| Test and Reports | How to generate multiple Tests or Metrics quickly? (Test and Metric Generators).           | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_apply_tests_and_metrics_generators.ipynb">Jupyter notebook</a></li></ul>                                                       |
| Test and Reports | How to calculate drift in embeddings?                                                      | <ul><li><a href="https://github.com/elenasamuylova/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_calculate_embeddings_drift.ipynb">Jupyter notebook</a></li></ul>                                                            |
| Test and Reports | How to run evaluations on raw text data? (Tests, Metrics and Presets that work with Text). | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_run_calculations_over_text_data.ipynb">Jupyter notebook</a></li></ul>                                                          |
| Test and Reports | How to use text descriptors in text-specific Metrics?                                      | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_use_text_descriptors_in_text_specific_metrics.ipynb">Jupyter notebook</a></li></ul>                                            |
| Test and Reports | How to use text descriptors in tabular Metrics and Tests?                                  | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_apply_table_metrics_and_tests_to_text_descriptors.ipynb">Jupyter notebook</a></li></ul>                                        |
| Test and Reports | How to calculate metrics for ranking and recommender systems?                              | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_run_recsys_metrics.ipynb">Jupyter notebook</a></li></ul>                                                                       |
| Test and Reports | How to import text data, convert to embeddings and detect drift?                           | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_run_drift_report_for_text_data.ipynb">Jupyter notebook</a></li></ul>                                                           |
| Test and Reports | How to set Test criticality as "warning"?                                                  | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_specify_test_criticality.ipynb">Jupyter notebook</a></li></ul>                                                                 |
| Test and Reports | How to save and load Test Suites and Reports as JSON "snapshots"?                          | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_use_snapshots.ipynb">Jupyter notebook</a></li></ul>                                                                            |
| Test and Reports | How to export Report results to a dataframe?                                               | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_get_report_as_a_dataframe.ipynb">Jupyter notebook</a></li></ul>                                                                |
| Test and Reports | How to run calculations on Spark?                                                          | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_run_calculations_on_spark.ipynb">Jupyter notebook</a></li></ul>                                                                |
| Customization    | How to assign a particular method for Data Drift detection?                                | <ul><li><a href="/pages/loKOxHo4NEuE2fwDQzBL">Guide</a></li><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_specify_stattest_for_a_testsuite.ipynb">Jupyter notebook</a></li></ul> |
| Customization    | How to define a custom list of Missing Values?                                             | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_run_tests_with_different_missing_values.ipynb">Jupyter notebook</a></li></ul>                                                  |
| Customization    | How to add a custom Metric or Test from scratch)?                                          | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_make_custom_metric_and_test.ipynb">Jupyter notebook</a></li></ul>                                                              |
| Customization    | How to add a custom Metric as a Python function?                                           | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_build_metric_over_python_function.ipynb">Jupyter notebook</a></li></ul>                                                        |
| Visual render    | How to add text comments to the Reports?                                                   | <ul><li><a href="/pages/33lbkn8DNTGMbST6iNbW">Guide</a></li><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_add_a_text_comment_to_the_report.ipynb">Jupyter notebook</a></li></ul> |
| Visual render    | How to specify a color scheme in Reports and Test Suites?                                  | <ul><li><a href="/pages/8jxXIvtEIiJ3rphCpyiF">Guide</a></li><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_customize_color_schema.ipynb">Jupyter notebook</a></li></ul>           |
| Visual render    | How to get non-aggregated visuals in Reports?                                              | <ul><li><a href="/pages/6fyWuaehumNZcWXvJ256">Guide</a></li><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_use_aggregated_data_option.ipynb">Jupyter notebook</a></li></ul>       |
| Outputs          | How to customize JSON output?                                                              | <ul><li><a href="/pages/DxdiCDlHGoVvfrLHWnzh">Guide</a></li><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_customize_json_output.ipynb">Jupyter notebook</a></li></ul>            |
| Outputs          | How to get Report or Test Suite output in csv?                                             | <ul><li><a href="https://github.com/evidentlyai/evidently/blob/ad71e132d59ac3a84fce6cf27bd50b12b10d9137/examples/how_to_questions/how_to_get_report_results_in_csv.ipynb">Jupyter notebook</a></li></ul>                                                                |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs-old.evidentlyai.com/user-guide/how-to-guides.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
